{
  Display the position of the cell of selection
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids,   ComCtrls, Db,
  DBTables,  StdCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    DataSource2: TDataSource;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    Table2: TTable;
    DataSource3: TDataSource;
    Table2CustNo: TFloatField;
    Table2Company: TStringField;
    Table2Addr1: TStringField;
    Table2Addr2: TStringField;
    Table2City: TStringField;
    Table2State: TStringField;
    Table2Zip: TStringField;
    Table2Country: TStringField;
    Table2Phone: TStringField;
    Table2FAX: TStringField;
    Table2TaxRate: TFloatField;
    Table2Contact: TStringField;
    Table2LastInvoiceDate: TDateTimeField;
    Button2: TButton;
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DBGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);  
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
//////////////////////////////////
type
  NKAIDgr = class(TCustomDBGrid);
///////////////////////////////////
 type
TNKGrid = class(TDBGrid)
   public
      property Row ;
      property Col ;
   end ;

procedure TForm1.DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var dataset: Tdataset;
begin

 (**) dataset := (Sender as TDBGrid).DataSource.DataSet;
  with NKAIDgr(Sender) do
  begin
    if (DataSet.RecNo mod 2 = 1) then
      Canvas.Brush.Color := $00EBFEEB     // Color
    else
      Canvas.Brush.Color := $00D7ECCA;   // Color

    if DataLink.ActiveRecord = Row - 1 then
    begin                                    
      Canvas.Font.Color := clwhite;  //font of selection
      Canvas.Brush.Color := clblack;  //back of selection
    end else
      if Table1Length_In.Value <= 20 then   
      Canvas.Font.Color := clRed;
    end;
  DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Query1.Active:=false;
Query1.ParamByName('Numero').AsInteger :=Table2CustNo.AsInteger;
Query1.Active:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//Table1.open; Table2.open;
end;

procedure TForm1.DBGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var  RR,LL:integer;

begin
    RR:=  TNKGrid(DBGrid1).Row ;
    LL:=  TNKGrid(DBGrid1).Col ;

    if dgIndicator in TNKGrid(DBGrid1).Options then
     TNKGrid(DBGrid1).Hint := 'Position : '+inttostr(RR)+'-th Row, '+inttostr(LL)+ '-th Column.';


end;

end.
