...
type
  TMyDBGrid = class(TDBGrid)
  published
    property OnMouseMove ;
  end ;
...  
     procedure WMMouseMove(var Message : TWMMouse) ; message WM_MOUSEMOVE;
...
public  
     MouseRow : integer ;
     MouseCol : integer ;
...
procedure TMyDBGrid.WMMouseMove(var Message : TWMMouse) ;
var
   t : TGridCoord ;
begin
     t := MouseCoord(Message.XPos, Message.YPos) ;
     MouseCol := t.x ;
     MouseRow := t.y ;
     inherited ;
end ;
(*Compile and install this new grid component. When you drop it on a form, 
you will see its OnMouseMove event available in the Object Inspector. 
We can use the new MouseRow and MouseCol properties to keep track 
of specifically where the user is pointing: *)

procedure TForm2.MyDBGrid1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
     if (((dgIndicator in MyDBGrid1.Options) and (MyDBGrid1.MouseCol > 0)) or
          ((not (dgIndicator in MyDBGrid1.Options)) and (MyDBGrid1.MouseCol <> -1)))
          and (MyDBGrid1.MouseCol <> OldMouseCol) then begin
        OldMouseCol := MyDBGrid1.MouseCol ;
        if dgIndicator in MyDBGrid1.Options then
           MYDBGrid1.Hint := MyDBGrid1.Columns[MyDBGrid1.MouseCol - 1].FieldName
        else
           MYDBGrid1.Hint := MyDBGrid1.Columns[MyDBGrid1.MouseCol].FieldName ;
     end ;
end ;
(* This is ever-so-close to a complete solution, but there is still one gaping
 flaw... the hint does not update and redisplay itself as you move the mouse
  over a new column! When you get to this point, you can be forgiven if you 
  have an impulse to hurl your computer through a window. I know that I definitely 
  felt that way... but I recovered enough to delve into the VCL source code. 
  Twas there that I discovered a public but undocumented method for the 
  TApplication object: *) 

   HintMouseMessage(Control : TControl ; var Message : TMessage)
//Declare the following variable within your OnMouseMove event: 

var
   r : TMessage ;
//Next, insert the following logic near the bottom of that event, just after the 
//assignment to the Hint property: 
   Application.HintMouseMessage(self, r) ;
   TWMMouse(r).XPos := X ;
   TWMMouse(r).YPos := Y ;
   Application.HintMouseMessage(MyDBGrid1, r) ;

